import json
import os


class DatasetParameters(object):

    def __init__(self, name, test_size, dev_size, random_state, normalize):
        self._name = name
        self._test_size = test_size
        self._dev_size = dev_size
        self._random_state = random_state
        self._normalize = normalize

    @property
    def name(self):
        return self._name
    
    @property
    def test_size(self):
        return self._test_size
    
    @property
    def dev_size(self):
        return self._dev_size

    @property
    def random_state(self):
        return self._random_state

    @property
    def normalize(self):
        return self._normalize

    def save(self, directory_path, experiment_id):
        with open(directory_path + os.sep + 'dataset_parameters_{}.json'.format(experiment_id), 'w') as output_file:
            json.dump({
                'name': self._name,
                'test_size': self._test_size,
                'dev_size': self._dev_size,
                'random_state': self._random_state,
                'normalize': self._normalize
            },
            output_file,
            indent=4)
