from bolsonaro.models.omp_forest_classifier import OmpForestClassifier
from bolsonaro.models.omp_forest_regressor import OmpForestRegressor
from bolsonaro.data.task import Task


class ModelFactory(object):

    @staticmethod
    def build(task, model_parameters):
        if task == Task.CLASSIFICATION:
            model_func = OmpForestClassifier
        elif task == Task.REGRESSION:
            model_func = OmpForestRegressor
        else:
            raise ValueError("Unsupported task '{}'".format(task))
        return model_func(model_parameters)
