import json
import os


class ModelParameters(object):

    def __init__(self, forest_size, extracted_forest_size, seed=None):
        self._forest_size = forest_size
        self._extracted_forest_size = extracted_forest_size
        self._seed = seed

    @property
    def forest_size(self):
        return self._forest_size

    @property
    def extracted_forest_size(self):
        return self._extracted_forest_size

    @property
    def seed(self):
        return self._seed

    def save(self, directory_path, experiment_id):
        with open(directory_path + os.sep + 'model_parameters_{}.json'.format(experiment_id), 'w') as output_file:
            json.dump({
                'forest_size': self._forest_size,
                'extracted_forest_size': self._extracted_forest_size,
                'seed': self._seed
            },
            output_file,
            indent=4)
