import matplotlib.pyplot as plt
import numpy as np
from sklearn.neighbors.kde import KernelDensity


class Plotter(object):

    @staticmethod
    def weight_density(weights):
        """
        TODO: to complete
        """
        X_plot = [np.exp(elem) for elem in weights]
        fig, ax = plt.subplots()

        for kernel in ['gaussian', 'tophat', 'epanechnikov']:
            kde = KernelDensity(kernel=kernel, bandwidth=0.5).fit(X_plot)
            log_dens = kde.score_samples(X_plot)
            ax.plot(X_plot[:, 0], np.exp(log_dens), '-',
                    label="kernel = '{0}'".format(kernel))

        ax.legend(loc='upper left')
        ax.plot(X[:, 0], -0.005 - 0.01 * np.random.random(X.shape[0]), '+k')

        ax.set_xlim(-4, 9)
        ax.set_ylim(-0.02, 0.4)
        plt.show()
